// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/LocationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/location_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'event_speed'
#include "etsi_its_denm_ts_msgs/msg/detail/speed__traits.hpp"
// Member 'event_position_heading'
#include "etsi_its_denm_ts_msgs/msg/detail/wgs84_angle__traits.hpp"
// Member 'detection_zones_to_event_position'
#include "etsi_its_denm_ts_msgs/msg/detail/traces__traits.hpp"
// Member 'road_type'
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__traits.hpp"
// Member 'lane_positions'
#include "etsi_its_denm_ts_msgs/msg/detail/generalized_lane_positions__traits.hpp"
// Member 'occupied_lanes'
#include "etsi_its_denm_ts_msgs/msg/detail/occupied_lanes_with_confidence__traits.hpp"
// Member 'linked_ivims'
#include "etsi_its_denm_ts_msgs/msg/detail/ivim_references__traits.hpp"
// Member 'linked_mapems'
#include "etsi_its_denm_ts_msgs/msg/detail/map_references__traits.hpp"
// Member 'detection_zones_to_specified_event_point'
#include "etsi_its_denm_ts_msgs/msg/detail/traces_extended__traits.hpp"
// Member 'predicted_paths'
#include "etsi_its_denm_ts_msgs/msg/detail/path_predicted_list__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LocationContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: event_speed
  {
    out << "event_speed: ";
    to_flow_style_yaml(msg.event_speed, out);
    out << ", ";
  }

  // member: event_speed_is_present
  {
    out << "event_speed_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_speed_is_present, out);
    out << ", ";
  }

  // member: event_position_heading
  {
    out << "event_position_heading: ";
    to_flow_style_yaml(msg.event_position_heading, out);
    out << ", ";
  }

  // member: event_position_heading_is_present
  {
    out << "event_position_heading_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_position_heading_is_present, out);
    out << ", ";
  }

  // member: detection_zones_to_event_position
  {
    out << "detection_zones_to_event_position: ";
    to_flow_style_yaml(msg.detection_zones_to_event_position, out);
    out << ", ";
  }

  // member: road_type
  {
    out << "road_type: ";
    to_flow_style_yaml(msg.road_type, out);
    out << ", ";
  }

  // member: road_type_is_present
  {
    out << "road_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_type_is_present, out);
    out << ", ";
  }

  // member: lane_positions
  {
    out << "lane_positions: ";
    to_flow_style_yaml(msg.lane_positions, out);
    out << ", ";
  }

  // member: lane_positions_is_present
  {
    out << "lane_positions_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_positions_is_present, out);
    out << ", ";
  }

  // member: occupied_lanes
  {
    out << "occupied_lanes: ";
    to_flow_style_yaml(msg.occupied_lanes, out);
    out << ", ";
  }

  // member: occupied_lanes_is_present
  {
    out << "occupied_lanes_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.occupied_lanes_is_present, out);
    out << ", ";
  }

  // member: linked_ivims
  {
    out << "linked_ivims: ";
    to_flow_style_yaml(msg.linked_ivims, out);
    out << ", ";
  }

  // member: linked_ivims_is_present
  {
    out << "linked_ivims_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_ivims_is_present, out);
    out << ", ";
  }

  // member: linked_mapems
  {
    out << "linked_mapems: ";
    to_flow_style_yaml(msg.linked_mapems, out);
    out << ", ";
  }

  // member: linked_mapems_is_present
  {
    out << "linked_mapems_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_mapems_is_present, out);
    out << ", ";
  }

  // member: detection_zones_to_specified_event_point
  {
    out << "detection_zones_to_specified_event_point: ";
    to_flow_style_yaml(msg.detection_zones_to_specified_event_point, out);
    out << ", ";
  }

  // member: detection_zones_to_specified_event_point_is_present
  {
    out << "detection_zones_to_specified_event_point_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.detection_zones_to_specified_event_point_is_present, out);
    out << ", ";
  }

  // member: predicted_paths
  {
    out << "predicted_paths: ";
    to_flow_style_yaml(msg.predicted_paths, out);
    out << ", ";
  }

  // member: predicted_paths_is_present
  {
    out << "predicted_paths_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.predicted_paths_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LocationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: event_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_speed:\n";
    to_block_style_yaml(msg.event_speed, out, indentation + 2);
  }

  // member: event_speed_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_speed_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_speed_is_present, out);
    out << "\n";
  }

  // member: event_position_heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_position_heading:\n";
    to_block_style_yaml(msg.event_position_heading, out, indentation + 2);
  }

  // member: event_position_heading_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_position_heading_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_position_heading_is_present, out);
    out << "\n";
  }

  // member: detection_zones_to_event_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detection_zones_to_event_position:\n";
    to_block_style_yaml(msg.detection_zones_to_event_position, out, indentation + 2);
  }

  // member: road_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_type:\n";
    to_block_style_yaml(msg.road_type, out, indentation + 2);
  }

  // member: road_type_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_type_is_present, out);
    out << "\n";
  }

  // member: lane_positions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_positions:\n";
    to_block_style_yaml(msg.lane_positions, out, indentation + 2);
  }

  // member: lane_positions_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_positions_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_positions_is_present, out);
    out << "\n";
  }

  // member: occupied_lanes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "occupied_lanes:\n";
    to_block_style_yaml(msg.occupied_lanes, out, indentation + 2);
  }

  // member: occupied_lanes_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "occupied_lanes_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.occupied_lanes_is_present, out);
    out << "\n";
  }

  // member: linked_ivims
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_ivims:\n";
    to_block_style_yaml(msg.linked_ivims, out, indentation + 2);
  }

  // member: linked_ivims_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_ivims_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_ivims_is_present, out);
    out << "\n";
  }

  // member: linked_mapems
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_mapems:\n";
    to_block_style_yaml(msg.linked_mapems, out, indentation + 2);
  }

  // member: linked_mapems_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_mapems_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_mapems_is_present, out);
    out << "\n";
  }

  // member: detection_zones_to_specified_event_point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detection_zones_to_specified_event_point:\n";
    to_block_style_yaml(msg.detection_zones_to_specified_event_point, out, indentation + 2);
  }

  // member: detection_zones_to_specified_event_point_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "detection_zones_to_specified_event_point_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.detection_zones_to_specified_event_point_is_present, out);
    out << "\n";
  }

  // member: predicted_paths
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "predicted_paths:\n";
    to_block_style_yaml(msg.predicted_paths, out, indentation + 2);
  }

  // member: predicted_paths_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "predicted_paths_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.predicted_paths_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LocationContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::LocationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::LocationContainer & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::LocationContainer>()
{
  return "etsi_its_denm_ts_msgs::msg::LocationContainer";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::LocationContainer>()
{
  return "etsi_its_denm_ts_msgs/msg/LocationContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::LocationContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::GeneralizedLanePositions>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::IvimReferences>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::MapReferences>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::PathPredictedList>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::RoadType>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::Speed>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::Traces>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::TracesExtended>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::Wgs84Angle>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::LocationContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::GeneralizedLanePositions>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::IvimReferences>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::MapReferences>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::PathPredictedList>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::RoadType>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::Speed>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::Traces>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::TracesExtended>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::Wgs84Angle>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::LocationContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__TRAITS_HPP_
