// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/OccupiedLanesWithConfidence.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/occupied_lanes_with_confidence__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'lane_position_based'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_options__traits.hpp"
// Member 'map_based'
#include "etsi_its_denm_ts_msgs/msg/detail/map_position__traits.hpp"
// Member 'confidence'
#include "etsi_its_denm_ts_msgs/msg/detail/meta_information__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const OccupiedLanesWithConfidence & msg,
  std::ostream & out)
{
  out << "{";
  // member: lane_position_based
  {
    if (msg.lane_position_based.size() == 0) {
      out << "lane_position_based: []";
    } else {
      out << "lane_position_based: [";
      size_t pending_items = msg.lane_position_based.size();
      for (auto item : msg.lane_position_based) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: map_based
  {
    if (msg.map_based.size() == 0) {
      out << "map_based: []";
    } else {
      out << "map_based: [";
      size_t pending_items = msg.map_based.size();
      for (auto item : msg.map_based) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: map_based_is_present
  {
    out << "map_based_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.map_based_is_present, out);
    out << ", ";
  }

  // member: confidence
  {
    out << "confidence: ";
    to_flow_style_yaml(msg.confidence, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OccupiedLanesWithConfidence & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lane_position_based
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.lane_position_based.size() == 0) {
      out << "lane_position_based: []\n";
    } else {
      out << "lane_position_based:\n";
      for (auto item : msg.lane_position_based) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: map_based
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.map_based.size() == 0) {
      out << "map_based: []\n";
    } else {
      out << "map_based:\n";
      for (auto item : msg.map_based) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: map_based_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_based_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.map_based_is_present, out);
    out << "\n";
  }

  // member: confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence:\n";
    to_block_style_yaml(msg.confidence, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OccupiedLanesWithConfidence & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence>()
{
  return "etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence>()
{
  return "etsi_its_denm_ts_msgs/msg/OccupiedLanesWithConfidence";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::OccupiedLanesWithConfidence>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__OCCUPIED_LANES_WITH_CONFIDENCE__TRAITS_HPP_
