// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/PathDeltaTimeChoice.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME_CHOICE__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME_CHOICE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/path_delta_time_choice__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'delta_time_high_precision'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_tenth_of_second__traits.hpp"
// Member 'delta_time_big_range'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_ten_seconds__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PathDeltaTimeChoice & msg,
  std::ostream & out)
{
  out << "{";
  // member: choice
  {
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << ", ";
  }

  // member: delta_time_high_precision
  {
    out << "delta_time_high_precision: ";
    to_flow_style_yaml(msg.delta_time_high_precision, out);
    out << ", ";
  }

  // member: delta_time_big_range
  {
    out << "delta_time_big_range: ";
    to_flow_style_yaml(msg.delta_time_big_range, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathDeltaTimeChoice & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "choice: ";
    rosidl_generator_traits::value_to_yaml(msg.choice, out);
    out << "\n";
  }

  // member: delta_time_high_precision
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "delta_time_high_precision:\n";
    to_block_style_yaml(msg.delta_time_high_precision, out, indentation + 2);
  }

  // member: delta_time_big_range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "delta_time_big_range:\n";
    to_block_style_yaml(msg.delta_time_big_range, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathDeltaTimeChoice & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice>()
{
  return "etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice>()
{
  return "etsi_its_denm_ts_msgs/msg/PathDeltaTimeChoice";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::DeltaTimeTenSeconds>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::DeltaTimeTenthOfSecond>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::DeltaTimeTenSeconds>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::DeltaTimeTenthOfSecond>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::PathDeltaTimeChoice>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_DELTA_TIME_CHOICE__TRAITS_HPP_
