// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/SituationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SITUATION_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SITUATION_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/situation_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'information_quality'
#include "etsi_its_denm_ts_msgs/msg/detail/information_quality__traits.hpp"
// Member 'event_type'
// Member 'linked_cause'
#include "etsi_its_denm_ts_msgs/msg/detail/cause_code_v2__traits.hpp"
// Member 'event_zone'
#include "etsi_its_denm_ts_msgs/msg/detail/event_zone__traits.hpp"
// Member 'linked_denms'
#include "etsi_its_denm_ts_msgs/msg/detail/action_id_list__traits.hpp"
// Member 'event_end'
#include "etsi_its_denm_ts_msgs/msg/detail/position1d__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SituationContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: information_quality
  {
    out << "information_quality: ";
    to_flow_style_yaml(msg.information_quality, out);
    out << ", ";
  }

  // member: event_type
  {
    out << "event_type: ";
    to_flow_style_yaml(msg.event_type, out);
    out << ", ";
  }

  // member: linked_cause
  {
    out << "linked_cause: ";
    to_flow_style_yaml(msg.linked_cause, out);
    out << ", ";
  }

  // member: linked_cause_is_present
  {
    out << "linked_cause_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_cause_is_present, out);
    out << ", ";
  }

  // member: event_zone
  {
    out << "event_zone: ";
    to_flow_style_yaml(msg.event_zone, out);
    out << ", ";
  }

  // member: event_zone_is_present
  {
    out << "event_zone_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_zone_is_present, out);
    out << ", ";
  }

  // member: linked_denms
  {
    out << "linked_denms: ";
    to_flow_style_yaml(msg.linked_denms, out);
    out << ", ";
  }

  // member: linked_denms_is_present
  {
    out << "linked_denms_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_denms_is_present, out);
    out << ", ";
  }

  // member: event_end
  {
    out << "event_end: ";
    to_flow_style_yaml(msg.event_end, out);
    out << ", ";
  }

  // member: event_end_is_present
  {
    out << "event_end_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_end_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SituationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: information_quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "information_quality:\n";
    to_block_style_yaml(msg.information_quality, out, indentation + 2);
  }

  // member: event_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_type:\n";
    to_block_style_yaml(msg.event_type, out, indentation + 2);
  }

  // member: linked_cause
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_cause:\n";
    to_block_style_yaml(msg.linked_cause, out, indentation + 2);
  }

  // member: linked_cause_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_cause_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_cause_is_present, out);
    out << "\n";
  }

  // member: event_zone
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_zone:\n";
    to_block_style_yaml(msg.event_zone, out, indentation + 2);
  }

  // member: event_zone_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_zone_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_zone_is_present, out);
    out << "\n";
  }

  // member: linked_denms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_denms:\n";
    to_block_style_yaml(msg.linked_denms, out, indentation + 2);
  }

  // member: linked_denms_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_denms_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_denms_is_present, out);
    out << "\n";
  }

  // member: event_end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_end:\n";
    to_block_style_yaml(msg.event_end, out, indentation + 2);
  }

  // member: event_end_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_end_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_end_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SituationContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::SituationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::SituationContainer & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::SituationContainer>()
{
  return "etsi_its_denm_ts_msgs::msg::SituationContainer";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::SituationContainer>()
{
  return "etsi_its_denm_ts_msgs/msg/SituationContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::SituationContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::ActionIdList>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::CauseCodeV2>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::EventZone>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::InformationQuality>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::Position1d>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::SituationContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::ActionIdList>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::CauseCodeV2>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::EventZone>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::InformationQuality>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::Position1d>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::SituationContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SITUATION_CONTAINER__TRAITS_HPP_
