// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/StationaryVehicleContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'stationary_since'
#include "etsi_its_denm_ts_msgs/msg/detail/stationary_since__struct.hpp"
// Member 'stationary_cause'
#include "etsi_its_denm_ts_msgs/msg/detail/cause_code_v2__struct.hpp"
// Member 'carrying_dangerous_goods'
#include "etsi_its_denm_ts_msgs/msg/detail/dangerous_goods_extended__struct.hpp"
// Member 'number_of_occupants'
#include "etsi_its_denm_ts_msgs/msg/detail/number_of_occupants__struct.hpp"
// Member 'vehicle_identification'
#include "etsi_its_denm_ts_msgs/msg/detail/vehicle_identification__struct.hpp"
// Member 'energy_storage_type'
#include "etsi_its_denm_ts_msgs/msg/detail/energy_storage_type__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct StationaryVehicleContainer_
{
  using Type = StationaryVehicleContainer_<ContainerAllocator>;

  explicit StationaryVehicleContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stationary_since(_init),
    stationary_cause(_init),
    carrying_dangerous_goods(_init),
    number_of_occupants(_init),
    vehicle_identification(_init),
    energy_storage_type(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stationary_since_is_present = false;
      this->stationary_cause_is_present = false;
      this->carrying_dangerous_goods_is_present = false;
      this->number_of_occupants_is_present = false;
      this->vehicle_identification_is_present = false;
      this->energy_storage_type_is_present = false;
    }
  }

  explicit StationaryVehicleContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stationary_since(_alloc, _init),
    stationary_cause(_alloc, _init),
    carrying_dangerous_goods(_alloc, _init),
    number_of_occupants(_alloc, _init),
    vehicle_identification(_alloc, _init),
    energy_storage_type(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stationary_since_is_present = false;
      this->stationary_cause_is_present = false;
      this->carrying_dangerous_goods_is_present = false;
      this->number_of_occupants_is_present = false;
      this->vehicle_identification_is_present = false;
      this->energy_storage_type_is_present = false;
    }
  }

  // field types and members
  using _stationary_since_type =
    etsi_its_denm_ts_msgs::msg::StationarySince_<ContainerAllocator>;
  _stationary_since_type stationary_since;
  using _stationary_since_is_present_type =
    bool;
  _stationary_since_is_present_type stationary_since_is_present;
  using _stationary_cause_type =
    etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator>;
  _stationary_cause_type stationary_cause;
  using _stationary_cause_is_present_type =
    bool;
  _stationary_cause_is_present_type stationary_cause_is_present;
  using _carrying_dangerous_goods_type =
    etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator>;
  _carrying_dangerous_goods_type carrying_dangerous_goods;
  using _carrying_dangerous_goods_is_present_type =
    bool;
  _carrying_dangerous_goods_is_present_type carrying_dangerous_goods_is_present;
  using _number_of_occupants_type =
    etsi_its_denm_ts_msgs::msg::NumberOfOccupants_<ContainerAllocator>;
  _number_of_occupants_type number_of_occupants;
  using _number_of_occupants_is_present_type =
    bool;
  _number_of_occupants_is_present_type number_of_occupants_is_present;
  using _vehicle_identification_type =
    etsi_its_denm_ts_msgs::msg::VehicleIdentification_<ContainerAllocator>;
  _vehicle_identification_type vehicle_identification;
  using _vehicle_identification_is_present_type =
    bool;
  _vehicle_identification_is_present_type vehicle_identification_is_present;
  using _energy_storage_type_type =
    etsi_its_denm_ts_msgs::msg::EnergyStorageType_<ContainerAllocator>;
  _energy_storage_type_type energy_storage_type;
  using _energy_storage_type_is_present_type =
    bool;
  _energy_storage_type_is_present_type energy_storage_type_is_present;

  // setters for named parameter idiom
  Type & set__stationary_since(
    const etsi_its_denm_ts_msgs::msg::StationarySince_<ContainerAllocator> & _arg)
  {
    this->stationary_since = _arg;
    return *this;
  }
  Type & set__stationary_since_is_present(
    const bool & _arg)
  {
    this->stationary_since_is_present = _arg;
    return *this;
  }
  Type & set__stationary_cause(
    const etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator> & _arg)
  {
    this->stationary_cause = _arg;
    return *this;
  }
  Type & set__stationary_cause_is_present(
    const bool & _arg)
  {
    this->stationary_cause_is_present = _arg;
    return *this;
  }
  Type & set__carrying_dangerous_goods(
    const etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator> & _arg)
  {
    this->carrying_dangerous_goods = _arg;
    return *this;
  }
  Type & set__carrying_dangerous_goods_is_present(
    const bool & _arg)
  {
    this->carrying_dangerous_goods_is_present = _arg;
    return *this;
  }
  Type & set__number_of_occupants(
    const etsi_its_denm_ts_msgs::msg::NumberOfOccupants_<ContainerAllocator> & _arg)
  {
    this->number_of_occupants = _arg;
    return *this;
  }
  Type & set__number_of_occupants_is_present(
    const bool & _arg)
  {
    this->number_of_occupants_is_present = _arg;
    return *this;
  }
  Type & set__vehicle_identification(
    const etsi_its_denm_ts_msgs::msg::VehicleIdentification_<ContainerAllocator> & _arg)
  {
    this->vehicle_identification = _arg;
    return *this;
  }
  Type & set__vehicle_identification_is_present(
    const bool & _arg)
  {
    this->vehicle_identification_is_present = _arg;
    return *this;
  }
  Type & set__energy_storage_type(
    const etsi_its_denm_ts_msgs::msg::EnergyStorageType_<ContainerAllocator> & _arg)
  {
    this->energy_storage_type = _arg;
    return *this;
  }
  Type & set__energy_storage_type_is_present(
    const bool & _arg)
  {
    this->energy_storage_type_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StationaryVehicleContainer_ & other) const
  {
    if (this->stationary_since != other.stationary_since) {
      return false;
    }
    if (this->stationary_since_is_present != other.stationary_since_is_present) {
      return false;
    }
    if (this->stationary_cause != other.stationary_cause) {
      return false;
    }
    if (this->stationary_cause_is_present != other.stationary_cause_is_present) {
      return false;
    }
    if (this->carrying_dangerous_goods != other.carrying_dangerous_goods) {
      return false;
    }
    if (this->carrying_dangerous_goods_is_present != other.carrying_dangerous_goods_is_present) {
      return false;
    }
    if (this->number_of_occupants != other.number_of_occupants) {
      return false;
    }
    if (this->number_of_occupants_is_present != other.number_of_occupants_is_present) {
      return false;
    }
    if (this->vehicle_identification != other.vehicle_identification) {
      return false;
    }
    if (this->vehicle_identification_is_present != other.vehicle_identification_is_present) {
      return false;
    }
    if (this->energy_storage_type != other.energy_storage_type) {
      return false;
    }
    if (this->energy_storage_type_is_present != other.energy_storage_type_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const StationaryVehicleContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StationaryVehicleContainer_

// alias to use template instance with default allocator
using StationaryVehicleContainer =
  etsi_its_denm_ts_msgs::msg::StationaryVehicleContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STATIONARY_VEHICLE_CONTAINER__STRUCT_HPP_
