// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/DangerousGoodsExtended.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_EXTENDED__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_EXTENDED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'dangerous_goods_type'
#include "etsi_its_denm_ts_msgs/msg/detail/dangerous_goods_basic__struct.hpp"
// Member 'phone_number'
#include "etsi_its_denm_ts_msgs/msg/detail/phone_number__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DangerousGoodsExtended_
{
  using Type = DangerousGoodsExtended_<ContainerAllocator>;

  explicit DangerousGoodsExtended_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : dangerous_goods_type(_init),
    phone_number(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->un_number = 0;
      this->elevated_temperature = false;
      this->tunnels_restricted = false;
      this->limited_quantity = false;
      this->emergency_action_code = "";
      this->emergency_action_code_is_present = false;
      this->phone_number_is_present = false;
      this->company_name = "";
      this->company_name_is_present = false;
    }
  }

  explicit DangerousGoodsExtended_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : dangerous_goods_type(_alloc, _init),
    emergency_action_code(_alloc),
    phone_number(_alloc, _init),
    company_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->un_number = 0;
      this->elevated_temperature = false;
      this->tunnels_restricted = false;
      this->limited_quantity = false;
      this->emergency_action_code = "";
      this->emergency_action_code_is_present = false;
      this->phone_number_is_present = false;
      this->company_name = "";
      this->company_name_is_present = false;
    }
  }

  // field types and members
  using _dangerous_goods_type_type =
    etsi_its_denm_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator>;
  _dangerous_goods_type_type dangerous_goods_type;
  using _un_number_type =
    uint16_t;
  _un_number_type un_number;
  using _elevated_temperature_type =
    bool;
  _elevated_temperature_type elevated_temperature;
  using _tunnels_restricted_type =
    bool;
  _tunnels_restricted_type tunnels_restricted;
  using _limited_quantity_type =
    bool;
  _limited_quantity_type limited_quantity;
  using _emergency_action_code_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _emergency_action_code_type emergency_action_code;
  using _emergency_action_code_is_present_type =
    bool;
  _emergency_action_code_is_present_type emergency_action_code_is_present;
  using _phone_number_type =
    etsi_its_denm_ts_msgs::msg::PhoneNumber_<ContainerAllocator>;
  _phone_number_type phone_number;
  using _phone_number_is_present_type =
    bool;
  _phone_number_is_present_type phone_number_is_present;
  using _company_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _company_name_type company_name;
  using _company_name_is_present_type =
    bool;
  _company_name_is_present_type company_name_is_present;

  // setters for named parameter idiom
  Type & set__dangerous_goods_type(
    const etsi_its_denm_ts_msgs::msg::DangerousGoodsBasic_<ContainerAllocator> & _arg)
  {
    this->dangerous_goods_type = _arg;
    return *this;
  }
  Type & set__un_number(
    const uint16_t & _arg)
  {
    this->un_number = _arg;
    return *this;
  }
  Type & set__elevated_temperature(
    const bool & _arg)
  {
    this->elevated_temperature = _arg;
    return *this;
  }
  Type & set__tunnels_restricted(
    const bool & _arg)
  {
    this->tunnels_restricted = _arg;
    return *this;
  }
  Type & set__limited_quantity(
    const bool & _arg)
  {
    this->limited_quantity = _arg;
    return *this;
  }
  Type & set__emergency_action_code(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->emergency_action_code = _arg;
    return *this;
  }
  Type & set__emergency_action_code_is_present(
    const bool & _arg)
  {
    this->emergency_action_code_is_present = _arg;
    return *this;
  }
  Type & set__phone_number(
    const etsi_its_denm_ts_msgs::msg::PhoneNumber_<ContainerAllocator> & _arg)
  {
    this->phone_number = _arg;
    return *this;
  }
  Type & set__phone_number_is_present(
    const bool & _arg)
  {
    this->phone_number_is_present = _arg;
    return *this;
  }
  Type & set__company_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->company_name = _arg;
    return *this;
  }
  Type & set__company_name_is_present(
    const bool & _arg)
  {
    this->company_name_is_present = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t UN_NUMBER_MIN =
    0u;
  static constexpr uint16_t UN_NUMBER_MAX =
    9999u;
  static constexpr uint8_t EMERGENCY_ACTION_CODE_MIN_SIZE =
    1u;
  static constexpr uint8_t EMERGENCY_ACTION_CODE_MAX_SIZE =
    24u;
  static constexpr uint8_t COMPANY_NAME_MIN_SIZE =
    1u;
  static constexpr uint8_t COMPANY_NAME_MAX_SIZE =
    24u;

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DangerousGoodsExtended_ & other) const
  {
    if (this->dangerous_goods_type != other.dangerous_goods_type) {
      return false;
    }
    if (this->un_number != other.un_number) {
      return false;
    }
    if (this->elevated_temperature != other.elevated_temperature) {
      return false;
    }
    if (this->tunnels_restricted != other.tunnels_restricted) {
      return false;
    }
    if (this->limited_quantity != other.limited_quantity) {
      return false;
    }
    if (this->emergency_action_code != other.emergency_action_code) {
      return false;
    }
    if (this->emergency_action_code_is_present != other.emergency_action_code_is_present) {
      return false;
    }
    if (this->phone_number != other.phone_number) {
      return false;
    }
    if (this->phone_number_is_present != other.phone_number_is_present) {
      return false;
    }
    if (this->company_name != other.company_name) {
      return false;
    }
    if (this->company_name_is_present != other.company_name_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const DangerousGoodsExtended_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DangerousGoodsExtended_

// alias to use template instance with default allocator
using DangerousGoodsExtended =
  etsi_its_denm_ts_msgs::msg::DangerousGoodsExtended_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t DangerousGoodsExtended_<ContainerAllocator>::UN_NUMBER_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t DangerousGoodsExtended_<ContainerAllocator>::UN_NUMBER_MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsExtended_<ContainerAllocator>::EMERGENCY_ACTION_CODE_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsExtended_<ContainerAllocator>::EMERGENCY_ACTION_CODE_MAX_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsExtended_<ContainerAllocator>::COMPANY_NAME_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DangerousGoodsExtended_<ContainerAllocator>::COMPANY_NAME_MAX_SIZE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_EXTENDED__STRUCT_HPP_
