// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/LanePositionWithLateralDetails.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_WITH_LATERAL_DETAILS__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_WITH_LATERAL_DETAILS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_with_lateral_details__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'transversal_position'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position__traits.hpp"
// Member 'lane_type'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_type__traits.hpp"
// Member 'direction'
#include "etsi_its_denm_ts_msgs/msg/detail/direction__traits.hpp"
// Member 'distance_to_left_border'
// Member 'distance_to_right_border'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length9b__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LanePositionWithLateralDetails & msg,
  std::ostream & out)
{
  out << "{";
  // member: transversal_position
  {
    out << "transversal_position: ";
    to_flow_style_yaml(msg.transversal_position, out);
    out << ", ";
  }

  // member: lane_type
  {
    out << "lane_type: ";
    to_flow_style_yaml(msg.lane_type, out);
    out << ", ";
  }

  // member: direction
  {
    out << "direction: ";
    to_flow_style_yaml(msg.direction, out);
    out << ", ";
  }

  // member: distance_to_left_border
  {
    out << "distance_to_left_border: ";
    to_flow_style_yaml(msg.distance_to_left_border, out);
    out << ", ";
  }

  // member: distance_to_right_border
  {
    out << "distance_to_right_border: ";
    to_flow_style_yaml(msg.distance_to_right_border, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LanePositionWithLateralDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: transversal_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "transversal_position:\n";
    to_block_style_yaml(msg.transversal_position, out, indentation + 2);
  }

  // member: lane_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_type:\n";
    to_block_style_yaml(msg.lane_type, out, indentation + 2);
  }

  // member: direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "direction:\n";
    to_block_style_yaml(msg.direction, out, indentation + 2);
  }

  // member: distance_to_left_border
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_to_left_border:\n";
    to_block_style_yaml(msg.distance_to_left_border, out, indentation + 2);
  }

  // member: distance_to_right_border
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_to_right_border:\n";
    to_block_style_yaml(msg.distance_to_right_border, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LanePositionWithLateralDetails & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails>()
{
  return "etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails>()
{
  return "etsi_its_denm_ts_msgs/msg/LanePositionWithLateralDetails";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::Direction>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::LanePosition>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::LaneType>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::StandardLength9b>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::Direction>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::LanePosition>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::LaneType>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::StandardLength9b>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::LanePositionWithLateralDetails>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_WITH_LATERAL_DETAILS__TRAITS_HPP_
