// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/PathId.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_ID__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_ID__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__MAX = 14
};

/// Constant 'NO_PATH'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__NO_PATH = 0
};

/// Constant 'PATH1'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH1 = 1
};

/// Constant 'PATH2'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH2 = 2
};

/// Constant 'PATH3'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH3 = 3
};

/// Constant 'PATH4'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH4 = 4
};

/// Constant 'PATH5'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH5 = 5
};

/// Constant 'PATH6'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH6 = 6
};

/// Constant 'PATH7'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH7 = 7
};

/// Constant 'PATH_EXTENDED1'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH_EXTENDED1 = 8
};

/// Constant 'PATH_EXTENDED2'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH_EXTENDED2 = 9
};

/// Constant 'PATH_EXTENDED3'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH_EXTENDED3 = 10
};

/// Constant 'PATH_EXTENDED4'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH_EXTENDED4 = 11
};

/// Constant 'PATH_EXTENDED5'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH_EXTENDED5 = 12
};

/// Constant 'PATH_EXTENDED6'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH_EXTENDED6 = 13
};

/// Constant 'PATH_EXTENDED7'.
enum
{
  etsi_its_denm_ts_msgs__msg__PathId__PATH_EXTENDED7 = 14
};

/// Struct defined in msg/PathId in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__PathId
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates an ordinal number that represents the position of a component in the list of @ref Traces or @ref TracesExtended.
  ///  *
  ///  * The value shall be set to:
  ///  * - `0` - noPath  - if no path is identified
  ///  * - `1..7`        - for instances 1..7 of @ref Traces
  ///  * - `8..14`       - for instances 1..7 of @ref TracesExtended.
  ///  *
  ///  * @category: Road topology information
  ///  * @revision: Created in V2.2.1
  /// */
  /// PathId ::= INTEGER {
  ///     noPath        (0),
  ///     path1         (1),
  ///     path2         (2),
  ///     path3         (3),
  ///     path4         (4),
  ///     path5         (5),
  ///     path6         (6),
  ///     path7         (7),
  ///     pathExtended1 (8),
  ///     pathExtended2 (9),
  ///     pathExtended3 (10),
  ///     pathExtended4 (11),
  ///     pathExtended5 (12),
  ///     pathExtended6 (13),
  ///     pathExtended7 (14)
  /// } (0..14)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_denm_ts_msgs__msg__PathId;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__PathId.
typedef struct etsi_its_denm_ts_msgs__msg__PathId__Sequence
{
  etsi_its_denm_ts_msgs__msg__PathId * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__PathId__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_ID__STRUCT_H_
