// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/Provider.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PROVIDER__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PROVIDER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/provider__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'country_code'
#include "etsi_its_denm_ts_msgs/msg/detail/country_code__traits.hpp"
// Member 'provider_identifier'
#include "etsi_its_denm_ts_msgs/msg/detail/issuer_identifier__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Provider & msg,
  std::ostream & out)
{
  out << "{";
  // member: country_code
  {
    out << "country_code: ";
    to_flow_style_yaml(msg.country_code, out);
    out << ", ";
  }

  // member: provider_identifier
  {
    out << "provider_identifier: ";
    to_flow_style_yaml(msg.provider_identifier, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Provider & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: country_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "country_code:\n";
    to_block_style_yaml(msg.country_code, out, indentation + 2);
  }

  // member: provider_identifier
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "provider_identifier:\n";
    to_block_style_yaml(msg.provider_identifier, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Provider & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::Provider & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::Provider & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::Provider>()
{
  return "etsi_its_denm_ts_msgs::msg::Provider";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::Provider>()
{
  return "etsi_its_denm_ts_msgs/msg/Provider";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::Provider>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::CountryCode>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::IssuerIdentifier>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::Provider>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::CountryCode>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::IssuerIdentifier>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::Provider>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PROVIDER__TRAITS_HPP_
