// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/RoadSectionDefinition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/road_section_definition__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'starting_point_section'
// Member 'ending_point_section'
#include "etsi_its_denm_ts_msgs/msg/detail/geo_position__traits.hpp"
// Member 'length_of_section'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length2_b__traits.hpp"
// Member 'connected_paths'
// Member 'included_paths'
#include "etsi_its_denm_ts_msgs/msg/detail/path_references__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RoadSectionDefinition & msg,
  std::ostream & out)
{
  out << "{";
  // member: starting_point_section
  {
    out << "starting_point_section: ";
    to_flow_style_yaml(msg.starting_point_section, out);
    out << ", ";
  }

  // member: length_of_section
  {
    out << "length_of_section: ";
    to_flow_style_yaml(msg.length_of_section, out);
    out << ", ";
  }

  // member: length_of_section_is_present
  {
    out << "length_of_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.length_of_section_is_present, out);
    out << ", ";
  }

  // member: ending_point_section
  {
    out << "ending_point_section: ";
    to_flow_style_yaml(msg.ending_point_section, out);
    out << ", ";
  }

  // member: ending_point_section_is_present
  {
    out << "ending_point_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.ending_point_section_is_present, out);
    out << ", ";
  }

  // member: connected_paths
  {
    out << "connected_paths: ";
    to_flow_style_yaml(msg.connected_paths, out);
    out << ", ";
  }

  // member: included_paths
  {
    out << "included_paths: ";
    to_flow_style_yaml(msg.included_paths, out);
    out << ", ";
  }

  // member: is_event_zone_included
  {
    out << "is_event_zone_included: ";
    rosidl_generator_traits::value_to_yaml(msg.is_event_zone_included, out);
    out << ", ";
  }

  // member: is_event_zone_connected
  {
    out << "is_event_zone_connected: ";
    rosidl_generator_traits::value_to_yaml(msg.is_event_zone_connected, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RoadSectionDefinition & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: starting_point_section
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "starting_point_section:\n";
    to_block_style_yaml(msg.starting_point_section, out, indentation + 2);
  }

  // member: length_of_section
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "length_of_section:\n";
    to_block_style_yaml(msg.length_of_section, out, indentation + 2);
  }

  // member: length_of_section_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "length_of_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.length_of_section_is_present, out);
    out << "\n";
  }

  // member: ending_point_section
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ending_point_section:\n";
    to_block_style_yaml(msg.ending_point_section, out, indentation + 2);
  }

  // member: ending_point_section_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ending_point_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.ending_point_section_is_present, out);
    out << "\n";
  }

  // member: connected_paths
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connected_paths:\n";
    to_block_style_yaml(msg.connected_paths, out, indentation + 2);
  }

  // member: included_paths
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "included_paths:\n";
    to_block_style_yaml(msg.included_paths, out, indentation + 2);
  }

  // member: is_event_zone_included
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_event_zone_included: ";
    rosidl_generator_traits::value_to_yaml(msg.is_event_zone_included, out);
    out << "\n";
  }

  // member: is_event_zone_connected
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_event_zone_connected: ";
    rosidl_generator_traits::value_to_yaml(msg.is_event_zone_connected, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RoadSectionDefinition & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::RoadSectionDefinition & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::RoadSectionDefinition & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition>()
{
  return "etsi_its_denm_ts_msgs::msg::RoadSectionDefinition";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition>()
{
  return "etsi_its_denm_ts_msgs/msg/RoadSectionDefinition";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::GeoPosition>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::PathReferences>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::StandardLength2B>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::GeoPosition>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::PathReferences>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::StandardLength2B>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__TRAITS_HPP_
